// Class definition for ConfigGroup
//
// Copyright Matthias Gaertner, Schenefeld, Germany, 2001
// You may use this code under the terms of the GPL.
// Updated packages may be found at http://www.rtner.de/parsled/
//

#ifndef __CONFIGGROUP_H
#define __CONFIGGROUP_H

#include <ParSledConfigClass.h>
#include <ConfigAction.h>


class ConfigGroup : public ParSledConfigClass
{
public:
    ConfigGroup();
    ~ConfigGroup();

    // 0: OK else error
    int feedLine( IConfigLine *icf );

    // 0: OK else error
    int checkOK();


    const SimpleString &getName( void );
    unsigned int getStart( void );
    unsigned int getMin( void );
    unsigned int getMax( void );

    unsigned int getState( void );
    void setState( unsigned int );

protected:
    SimpleString    _name_x;
    unsigned int    _start;
    unsigned int    _min;
    unsigned int    _max;

    // Application state is held inside the configuration object.
    unsigned int    _state;
};

#endif /* __CONFIGGROUP_H */

/* */
