// interface definition for IConfiguration
//
// Copyright Matthias Gaertner, Schenefeld, Germany, 2001
// You may use this code under the terms of the GPL.
// Updated packages may be found at http://www.rtner.de/parsled/
//

#ifndef __ICONFIGURATION_H
#define __ICONFIGURATION_H

#include <stdio.h>
#include <SimpleString.h>
#include <IConfigurationSource.h>
#include <IConfigClass.h>


class IConfiguration
{
public:
    virtual ~IConfiguration() = 0;

    virtual void reset( void ) = 0;
    virtual int feedConfiguration( IConfigurationSource *ics ) = 0;
    virtual int feedConfiguration( const SimpleString *s ) = 0;
    virtual int feedConfiguration( FILE *f ) = 0;

    virtual IConfigClass *getSection( SimpleString *s ) const = 0;

protected:
    virtual void notifySectionStart( const SimpleString *name );
    virtual void notifySectionStop( const SimpleString *name, IConfigClass *cl );
    virtual void notifyLine( const IConfigLine *line );
};

#endif /* __ICONFIGURATION_H */

/* */
