// Class definition for ParSledExecutor
//
// Copyright Matthias Gaertner, Schenefeld, Germany, 2001
// You may use this code under the terms of the GPL.
// Updated packages may be found at http://www.rtner.de/parsled/
//

#ifndef __PARSLEDEXECUTOR_H
#define __PARSLEDEXECUTOR_H

#include <stdio.h>
#include <ParSledConfiguration.h>
#include <ConfigAction.h>
#include <ConfigLed.h>


class ParSledExecutor
{
public:
    ParSledExecutor();
    ~ParSledExecutor();

    int start( ParSledConfiguration * );
    int execute( void );
    int stop();

protected:
    unsigned int         _countButtonPressed;
    int                  _fd;
    ParSledConfiguration *_sc;

    int _buttonPressed( void );
    int _setLED( int n, bool on_off );
    int _execute( ConfigAction *ca );
    int _buttonPressDetected( void );
    int _handleLEDs( void );
    int _handleLED( ConfigLed *cl );

#ifdef SIMULATION
    int _press;
#else
    int _lstate;
    enum { serial, parport } _interfacetype;
#endif
    int _getRunlevel( void );
};

#endif /* __PARSLEDEXECUTOR_H */

/* */
